
args=commandArgs(trailingOnly = TRUE)
#setwd(args[1])
#paste(args[1],"/model/output_5end_bin10_groseq.txt", sep = "")
counts<-read.table(args[2],as.is=T,sep="\t")
if (args[3]=="GRO"){
    default<-read.table(paste(args[1],"/model/output_5end_bin10_groseq.txt", sep = ""),as.is=T,sep="\t",header=T)
    bg=0.008
} else if (args[3]=="PRO"){
    default<-read.table(paste(args[1],"/model/output_3end_bin10_proseq.txt",sep= ""),as.is=T,sep="\t",header=T)
   bg=0.014
   }


gene<-unique(counts[,4])



windowsize=100
binsize=10
cutoff_plus=3
cutoff_minus=1
gb_bg=0.001




result<-NULL

for (genenum in 1:length(gene)){
    genename<-gene[genenum]
  
    ind<-which(counts[,4]==genename)
     genecount<-counts[ind,]



    len<-dim(genecount)[1]
    ind<-c(seq(1,len,windowsize),len)
    strand<-genecount[1,5]
    score<-NULL

   for (i in 1:(length(ind)-1)){
         count_plus<-sum(genecount[ind[i]:(ind[i+1]-1),6])
         count_minus<-sum(genecount[ind[i]:(ind[i+1]-1),7])
         if (count_plus > cutoff_plus & count_minus> cutoff_minus  ) {
             for (start in ind[i]:(ind[i+1]-1)) {
                 if (start>50) {
                      count_plus<-genecount[(start-50):(start+50),6]
                      count_minus<-genecount[(start-50):(start+50),7]
                      count_plus<-count_plus[!is.na(count_plus)]
                      count_minus<-count_minus[!is.na(count_minus)]
                      if (strand=="-"){
                          count_plus<-rev(count_plus)
                          count_minus<-rev(count_minus)
                          }
             
                       plus_score<-sum(count_plus/binsize*log(default[1:length(count_plus),3]/bg))   
   
                       minus_score<-sum(count_minus/binsize*log(default[1:length(count_minus),4]/bg)) 
                       pvalue<-pval_con<-plus_num<-NA 
                   
                       if (strand=="+" & start+100<len) {
                  
                           plus_con<-sum(genecount[(start+100):len,6])
                           minus_con<-sum(genecount[(start+100):len,7])
                           gb_density<-(len-start-100)*gb_bg*binsize
                            pvalue<-ppois(plus_con,lambda=gb_density,lower=FALSE) 

                           seqind<-seq(start+100,len,500) ###consider a window of 5k
                           
                           if (length(seqind)>1) {
                                   pval_con<-NULL
                                   plus_num<-NULL
                                   for ( seqstart in 1 :(length(seqind)-1)) {
                                       
                                         plus_con<-sum(genecount[seqind[seqstart]:seqind[seqstart+1],6])
                                         gb_density<-5000*gb_bg/2
                                         pval_con<-c(pval_con,ppois(plus_con,lambda=gb_density,lower=FALSE))
                                         plus_num<-c(plus_num,plus_con)

                                      }                          
 
                               }


                           }
        
                       if (strand=="-" & start-100>1){
                            
                            plus_con<-sum(genecount[1:(start-100),6])
                            minus_con<-sum(genecount[1:(start-100),7])
                            gb_density<-(start-100)*gb_bg*binsize
                            pvalue<-ppois(plus_con,lambda=gb_density,lower=FALSE)



                           seqind<-seq(1,start+100,500) ###consider a window of 5k
                          
                           if (length(seqind)>1) {
                                    pval_con<-plus_num<-NULL
                                   for ( seqstart in 1 :(length(seqind)-1)) {
                                       
                                         plus_con<-sum(genecount[seqind[seqstart]:seqind[seqstart+1],6])
                                         gb_density<-5000*gb_bg/2
                                         pval_con<-c(pval_con,ppois(plus_con,lambda=gb_density,lower=FALSE))
                                         plus_num<-c(plus_num,plus_con)

                                      }                          
 
                               }
 
                           }     
                       score<-rbind(score,c(genecount[start,1:3],strand,plus_score,minus_score,pvalue,max(pval_con),min(plus_num)))
                       }
  
          } 
         }

    }

 result<-c(result,list(score=score))

 }







names(result)<-gene

#for ( i in 1:length(result)){
  # if (!is.null(result[[i]]))
  #   write.table(cbind(result[[i]],names(result)[i]),file=paste(args[1],".result",sep=""),append=T,sep="\t",quote=F,row.names=F,col.names=F)
# }


total<-as.numeric(args[4])
norm<-total/388
stringent_sense<-18*norm
stringent_antisense<-9*norm
medium_sense<-8*norm
medium_antisense<-4*norm
relax_sense<-3*norm
relax_antisense<-1.5*norm

maxscore_stringent<-maxscore_relax<-maxscore_medium<-NULL

for (i in 1:length(result)){
  if (!is.null(result[[i]])){
 
          temp<-result[[i]]
   
             temp_sel<-temp[as.numeric(temp[,5])>stringent_sense & as.numeric(temp[,6])>stringent_antisense  & (!is.na(temp[,7]) & as.numeric(temp[,7])<0.0001) & (is.na(temp[,9]) | temp[,9]>10),]
             temp_sel<-matrix(temp_sel,ncol=9)

             
             if ( dim(temp_sel)[1]!=0 ) {
              
   
                  maxind<-which.max(as.numeric(temp_sel[,5])+as.numeric(temp_sel[,6]))
                  maxscore_stringent<-rbind(maxscore_stringent,c(names(result)[i], temp_sel[maxind,]))
                }
            
          temp_sel<-temp[as.numeric(temp[,5])>medium_sense & as.numeric(temp[,6])>medium_antisense  & (!is.na(temp[,7]) & as.numeric(temp[,7])<0.0001) & (is.na(temp[,9]) | temp[,9]>5),]

        temp_sel<-matrix(temp_sel,ncol=9)

             if ( dim(temp_sel)[1]!=0 ) {
 
 
                  maxind<-which.max(as.numeric(temp_sel[,5])+as.numeric(temp_sel[,6]))
                  maxscore_medium<-rbind(maxscore_medium,c(names(result)[i],temp_sel[maxind,]))
                }
            temp_sel<-temp[as.numeric(temp[,5])>relax_sense & as.numeric(temp[,6])>relax_antisense  & (!is.na(temp[,7]) & as.numeric(temp[,7])<0.0001) & (is.na(temp[,9]) | temp[,9]>2),]
            temp_sel<-matrix(temp_sel,ncol=9)

             if ( dim(temp_sel)[1]!=0 ) {
 
 
                  maxind<-which.max(as.numeric(temp_sel[,5])+as.numeric(temp_sel[,6]))
                  maxscore_relax<-rbind(maxscore_relax,c(names(result)[i],temp_sel[maxind,]))
                }
 
        }


} 


processoutput<-function(maxscore){
 if (!is.null(maxscore)){
     tss_pos<-(as.numeric(maxscore[,3])+as.numeric(maxscore[,4]))/2


     maxscore<-cbind(maxscore[,1:2],tss_pos, maxscore[,c(5:8,10)])
     colnames(maxscore)<-c("miRNA","Chr","TSS","Strand","Score_plus","Score_minus","Pvalue_gb","Num_5k")
    return(maxscore) } else return(NULL)
}

maxscore_stringent_output<-processoutput(maxscore_stringent)
maxscore_medium_output<-processoutput(maxscore_medium)
maxscore_relax_output<-processoutput(maxscore_relax)



write.table(maxscore_stringent_output,file=paste(args[5],"_mirSTP_stringent.txt", sep = ""),sep="\t",quote=F,row.names=F,col.names=T)

write.table(maxscore_medium_output,file=paste(args[5],"_mirSTP_medium.txt", sep = ""),sep="\t",quote=F,row.names=F,col.names=T)

write.table(maxscore_relax_output,file=paste(args[5],"_mirSTP_relax.txt", sep = ""),sep="\t",quote=F,row.names=F,col.names=T)

